#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QDebug>
#include <QDirIterator>
#include <QFileDialog>

MainWindow::MainWindow(QWidget *parent) :
	QMainWindow(parent),
	ui(new Ui::MainWindow)
{
	ui->setupUi(this);
	dirPath = "/";
}

MainWindow::~MainWindow()
{
	delete ui;
}

void MainWindow::on_pushButton_clicked()
{
	int i=0;
	ui->textEdit->append("Button Clicked " + QString::number(++clickCount));

	/// Add QDirIterator per creare la lista
	/// Si assume che la directory esista
	QDirIterator dirIter(dirPath, QDirIterator::NoIteratorFlags);  // si può aggiungere qualche flag per la ricerca nelle subDir

	// Cancello tutti gli elementi
	ui->treeWidget->clear();

	// Ricostruisco gli elementi
	while (dirIter.hasNext())
	{
		QString dirName = dirIter.next();

		qDebug() << dirName;

		// Creo e aggiungo il nuovo item, che compone una intera linea
		QTreeWidgetItem *item = new QTreeWidgetItem();
		item->setText(0, dirName);
		item->setIcon(0,QIcon("../icons/directory.png"));
		item->setText(1, "dir number "+QString::number(i));
		ui->treeWidget->insertTopLevelItem(i++,item);

		// Aggiungo un sub-item all'item appena generato
		item = new QTreeWidgetItem(item);
		item->setText(0, "Sub-Item");
	}
}

void MainWindow::on_buttonChangeDir_clicked()
{
	dirPath = QFileDialog::getExistingDirectory(this,
												"Choose Directory",
												QDir::homePath());
	if(dirPath.isEmpty())
		dirPath = "/";
}
