#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <QDebug>
#include <QDirIterator>
#include <QFileDialog>


MainWindow::MainWindow(QWidget *parent) :
	QMainWindow(parent),
	ui(new Ui::MainWindow)
{
	ui->setupUi(this);
	dirPath = "/";
}

MainWindow::~MainWindow()
{
	delete ui;
}

void MainWindow::on_pushButton_clicked()
{
	int i=0;
	ui->textEdit->append("Button Clicked " + QString::number(++clickCount));

	/// Add QDirIterator per creare la lista
	/// Si assume che la directory esista
	QDirIterator dirIter(dirPath, QDirIterator::NoIteratorFlags);  // si può aggiungere qualche flag per la ricerca nelle subDir

	// Cancello tutti gli elementi
	ui->treeWidget->clear();

	// Ricostruisco gli elementi
	while (dirIter.hasNext())
	{
		QString dirName = dirIter.next();

		qDebug() << dirName;

		// Creo e aggiungo il nuovo item, che compone una intera linea
		QTreeWidgetItem *item = new QTreeWidgetItem();
		item->setText(0, dirName);
		item->setIcon(0,QIcon("../icons/directory.png"));
		item->setText(1, "dir number "+QString::number(i));
		ui->treeWidget->insertTopLevelItem(i++,item);

		// Aggiungo un sub-item all'item appena generato
		item = new QTreeWidgetItem(item);
		item->setText(0, "Sub-Item");
	}
}

void MainWindow::on_buttonChangeDir_clicked()
{
	dirPath = QFileDialog::getExistingDirectory(this,
												"Choose Directory",
												QDir::homePath());
	if(dirPath.isEmpty())
		dirPath = "/";
}

/**
 * @brief MainWindow::on_treeWidget_itemClicked
 * Siccome la funzione dragMouseMove sembra troppo pesante in quanto continua a ridefinire i dati da trasmettere,
 * allora si preferisce creare sempre i dati del D&D direttamente ogni volta che un item viene cliccato
 * @param item
 * @param column
 */
void MainWindow::on_treeWidget_itemClicked(QTreeWidgetItem *item, int column)
{
/*	// Distruggo i dati se sono stati precedentemente creati
	if(ui->treeWidget->drag != Q_NULLPTR)
		delete ui->treeWidget->drag;
	if(ui->treeWidget->mimeData != Q_NULLPTR)
		delete ui->treeWidget->mimeData;

	// Creo i dati D&D secondo la documentazione
	ui->treeWidget->drag = new QDrag(ui->treeWidget);	// non uso "this" perchè i dati sono relativi al treeWidget e non al MainWindow
	ui->treeWidget->mimeData = new QMimeData;

	// carico i dati e li definisco con il MiMe: testo e immagini secondo i MiMe di default
	ui->treeWidget->mimeData->setText(item->text(0)+"|"+item->text(1));
	ui->treeWidget->mimeData->setImageData(item->icon(0));

	// Carico i MiMe nel drag così da rendere visibile le info anche agli altri programmi
	// e carico po gli stessi dati anche nel drag:
	ui->treeWidget->drag->setMimeData(ui->treeWidget->mimeData);
//	ui->treeWidget->drag->setPixmap(QPixmap(item->icon(0).pixmap()));

	Qt::DropAction dropAction = ui->treeWidget->drag->exec();

	qDebug() << __func__ << "Drag&Drop data created";
*/
}
