#include "myTreeWidget.h"
#include <QDebug>

myTreeWidget::myTreeWidget(QWidget *parent) : QTreeWidget(parent)
{
}

void myTreeWidget::dragEnterEvent(QDragEnterEvent *event)
{
	// Eredito le vecchie funzionalità:
	QTreeWidget::dragEnterEvent(event);

	// Eseguo le nuove funzionalità
	qDebug() << __func__;
}

void myTreeWidget::dragMoveEvent(QDragMoveEvent *event)
{
	static int i = 0;

	// Eredito le vecchie funzionalità:
	QTreeWidget::dragMoveEvent(event);

	// Eseguo le nuove funzionalità
	qDebug() << __func__ << i++;
}

void myTreeWidget::dropEvent(QDropEvent *event)
{
	// Eredito le vecchie funzionalità:
	QTreeWidget::dropEvent(event);

	// Eseguo le nuove funzionalità
	qDebug() << __func__;
}

void myTreeWidget::mousePressEvent(QMouseEvent *event)
{
	// Questa funzione va chiamata subito per mantenere inalterato il comportamento del widget.
	// In particolare permette di continuare a selezionare gli item
	QTreeWidget::mousePressEvent(event);

	// Eredito le vecchie funzionalità:
	if(!(event->buttons() & Qt::LeftButton))
		return;

	if(selectedItems().isEmpty())
		return;

	QDrag *drag = new QDrag(this);
	QMimeData *mimeData = new QMimeData;

	// carico i dati e li definisco con il MiMe: testo e immagini secondo i MiMe di default
	if(currentItem()->icon(0).isNull())
		mimeData->setText(currentItem()->text(0)+"|"+currentItem()->text(1));
	else
		mimeData->setImageData(QImage("../icons/directory.png")); //currentItem()->icon(0));

	// Carico i MiMe nel drag così da rendere visibile le info anche agli altri programmi
	// e carico po gli stessi dati anche nel drag:
	drag->setMimeData(mimeData);
	drag->setPixmap(QPixmap(currentItem()->icon(0).pixmap(50,50)));

	Qt::DropAction dropAction = drag->exec(Qt::CopyAction | Qt::MoveAction);

	// Eseguo le nuove funzionalità
	qDebug() << __func__;
}

/**
void myTreeWidget::mouseMoveEvent(QMouseEvent *event)
{
	// Eredito le vecchie funzionalità:
	QTreeWidget::mouseMoveEvent(event);

	// Eseguo le nuove funzionalità
	qDebug() << __func__;
}
**/
