#include "customwidget.h"
#include <QDebug>
#include <QPainter>
#include <QKeyEvent>

CustomWidget::CustomWidget(QWidget *parent) : QWidget(parent)
{
	compAngle = 360*16-mainAngle;
}

void CustomWidget::paintEvent(QPaintEvent *)
{
	QPainter painter(this);

	minSize = width() > height() ? height() : width();
	QRectF square = QRectF(CustomPad, CustomPad, minSize-CustomPad, minSize-CustomPad);

	painter.setBrush(Qt::blue);
	painter.drawPie(square, 0, mainAngle);

	painter.setBrush(Qt::green);
	painter.drawPie(square, mainAngle, compAngle);
}

void CustomWidget::keyPressEvent(QKeyEvent *event)
{
	switch(event->key())
	{
	case Qt::Key_Up:
		mainAngle += 10*16;
		if (mainAngle > 360*16)
			mainAngle = 360*16;
		compAngle = 360*16-mainAngle;
		qDebug() << "Angle:" << mainAngle;
		update();	// Ridisegna la pipe
		break;

	case Qt::Key_Down:
		mainAngle = (mainAngle - 10*16)%(360*16);
		if (mainAngle < 0)
			mainAngle = 0;
		compAngle = 360*16-mainAngle;
		qDebug() << "Angle:" << mainAngle;
		update();	// Ridisegna la pipe
		break;

	case Qt::Key_0 ... Qt::Key_9:
	case Qt::Key_A ... Qt::Key_Z:
		emit charKey(event->key());
		break;
	}

}
